unit Legacy;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ShellApi;

type
  TAdressType = (atMail, atWWW);
  TLegacy = class(TCustomLabel)
  private
    FAdress: string;
    FAdressType: TAdressType;
    FActiveColor: TColor;
    FOldColor: TColor;
    FOnMouseEnter: TNotifyEvent;
    FOnMouseExit: TNotifyEvent;
    procedure SetAdressType(Value: TAdressType);
    procedure CMMouseEnter(var Message: TMessage); message CM_MOUSEENTER;
    procedure CMMouseLeave(var Message: TMessage); message CM_MOUSELEAVE;
  protected
    procedure Click; override;
  public
    constructor Create(AOwner: TComponent); override;
  published
    property Adress: string read FAdress write FAdress;
    property AdressType: TAdressType read FAdressType write SetAdressType;
    property Align;
    property Alignment;
    property AutoSize;
    property Caption;
    property Color;
    property ActiveColor: TColor read FActiveColor write FActiveColor;
    property DragCursor;
    property DragMode;
    property Enabled;
    property FocusControl;
    property Font;
    property ParentColor;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowAccelChar;
    property ShowHint;
    property Transparent;
    property Layout;
    property Visible;
    property WordWrap;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseEnter: TNotifyEvent read FOnMouseEnter write FOnMouseEnter;
    property OnMouseExit: TNotifyEvent read FOnMouseExit write FOnMouseExit;
    property OnMouseUp;
    property OnStartDrag;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('A-Team', [TLegacy]);
end;

constructor TLegacy.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FAdressType:=atWWW;
  FActiveColor:=clRed;
end;

procedure TLegacy.SetAdressType(Value: TAdressType);
begin
  if Value=FAdressType then Exit;
  FAdressType:=Value;
end;

procedure TLegacy.Click;
begin
  Cursor := crAppStart;
  Application.Processmessages; {otherwise cursor change will be missed}
  if (FAdressType=atWWW) and (FAdress<>'') then
    ShellExecute(0, Nil, PChar(FAdress), Nil, Nil, SW_NORMAL)
  else ShellExecute(0, Nil, PChar('mailto:'+FAdress), Nil, Nil, SW_NORMAL);
  Cursor := crHandPoint;
  inherited Click;
end;

procedure TLegacy.CMMouseEnter(var Message: TMessage);
begin
  FOldColor:=Font.Color;
  Font.Style:=Font.Style+[fsUnderline];
  Cursor:=crHandPoint;
  Application.Processmessages;
  Font.Color:=FActiveColor;
  if Assigned(FOnMouseEnter) then FOnMouseEnter(self);
end;

procedure TLegacy.CMMouseLeave(var Message: TMessage);
begin
  Cursor:=crDefault;
  Font.Style:=Font.Style-[fsUnderline];
  Application.Processmessages;
  Font.Color:=FOldColor;
  if Assigned(FOnMouseExit) then FOnMouseExit(self);
end;

end.
